$(".alert-dismissible").fadeOut(0);
var table;
$(document).ready(function () 
{
    table = $('#datatable-fixedheader').DataTable({
        retrieve: true,
        columnDefs: [],
        "processing": true,
        "serverSide": true,
        "lengthChange": true,
        "ordering": true,
        'autoWidth': false,
        "pagingType": "full_numbers",
        "iDisplayLength": 10,
        "lengthMenu": [
            [10, 25, 50, -1],
            [10, 25, 50, "All"]
        ],
        "order": [], //Initial no order.
        // Load data for the table's content from an Ajax source
        "ajax": {
            "url": BASEURL + 'imagecategory-list',
            "type": "POST"
        },
        //Set column definition initialisation properties.
        "columnDefs": [{
            "targets": [0, 3, 5], 
            "orderable": false, //set not orderable            
        },  
        ],

        "fnInitComplete": function () 
        { 
            $(".dt-container .dt-search").append('<button type="button" id="cb-add" class="btn btn-secondary waves-effect waves-light" data-bs-toggle="modal" data-bs-target=".modal1" onclick="add_data()">+ Add New</button>');
        },

    });
});


function reload_table() 
{
    table.ajax.reload(null,false); //reload datatable ajax 
}

$('.modal').on('shown.bs.modal', function () {
    $('[name="cat_name"]').focus()
})

var save_method;
function add_data() 
{
    
    save_method = 'add';
    $('#id').val(''); 
     
    $('#form').parsley().reset();
    $('#form')[0].reset();
    $(".modal-title").html('Add Image Category');
    $('#submit').attr('disabled', false);    
    $("#submit").html('Save');     
}

function edit_data(id) 
{
    save_method = 'update';
    
    $('#form').parsley().reset();
    $('#form')[0].reset();
    $(".modal-title").html('Edit Image Category');
    $("#submit").html('Update');
    $('#submit').attr('disabled', false);
    $('.modal1').modal('show');    

    $.ajax({
        url: BASEURL + 'imagecategory/edit/' + id,
        type: "GET",
        dataType: "JSON",
        success: function (data) {
            $('[name="id"]').val(data.id);
            $('[name="cat_name"]').val(data.cat_name); 
            // $('[name="description"]').val(data.description); 
            $('[name="sequence_no"]').val(data.sequence_no);  
  
 
            $("#btnSave").html('Update');
            $('#modal').modal('show');
        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert('Error! Get data from database.');
        }
    });
} 
 
function deactive(id) 
{
    $.ajax({
        type: "POST",
        url: BASEURL + 'imagecategory/deactive/' + id,
        data: "id=" + id,
        dataType: "json",
        success: function (data) {
            if (data == 'sucess') {
                reload_table();
            } else {
                alert('Status Update Fail');
            }
        }
    });
}

function active(id) 
{
    $.ajax({
        type: "POST",
        url: BASEURL + 'imagecategory/active/' + id,
        data: "id=" + id,
        dataType: "json",
        success: function (data) {
            if (data == 'sucess') {
                reload_table();
            } else {
                alert('Status Update Fail');
            }
        }
    });
}
 

$(document).on("click", ".delete_btn", function (event) {
var id = $(this).attr('data-id');  
var t = Swal.mixin({
        customClass: {
            confirmButton: "btn btn-success mx-1",
            denyButton: "btn btn-secondary mx-1",
            cancelButton: "btn btn-danger mx-1"
        },
        buttonsStyling: !1
    }),
    e = Swal.mixin({
        toast: !0,
        position: "top-end",
        showConfirmButton: !1,
        timer: 3e3,
        timerProgressBar: !0,
        didOpen: function(t) {
            t.addEventListener("mouseenter", Swal.stopTimer), t.addEventListener("mouseleave", Swal.resumeTimer)
        }
    });
     t.fire({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        icon: "warning",
        showCancelButton: !0,
        confirmButtonColor: "#34c38f",
        cancelButtonColor: "#f03b3b",
        confirmButtonText: "Yes, delete it!",
        cancelButtonText: "No, cancel!"
    }).then(
    function (t) {
        if (t.value) {
            var $url = BASEURL + 'imagecategory/delete/' + id;
            $.ajax({
                type: 'POST',
                url: $url,
                async: false,
                data: {
                    id: id
                },
                dataType: 'json',
                beforeSend: function () {
                    $('.dataTables_processing').css('visibility', 'visible');
                },
                success: function (returnData) {
                    if (returnData.status == 'ok') {
                        Swal.fire({
                            title: "Deleted!",
                            text: "Record has been deleted.",
                            icon: "success"
                        })
                        reload_table();
                    } else if (returnData.status == 'not') {
                        var tbc_name = returnData.tbc_name;
                        Swal.fire({
                            title: "Cancelled",
                            text: "Record can't delete, Because they are used in " + tbc_name + ".",
                            icon: "error"
                        })
                        reload_table();
                    }
                },
                complete: function () {
                    $('.dataTables_processing').css('visibility', 'hidden');
                }
            });
        } else {
            t.dismiss === Swal.DismissReason.cancel && Swal.fire({
                title: "Cancelled",
                text: "Congrates! Your data is safe.",
                icon: "error"
            })
        }
    })
}); 
 
$('#form').submit(function (e) 
{
    if ($('#form').parsley().isValid()) 
    { 
        var get_id = $('#id').val();
         
            // $(".dropzone").removeClass("dropzone_required");
            $('#submit').attr('disabled', false);
            e.preventDefault();
            $.ajax({
                url: BASEURL + 'imagecategory/submit',
                type: "POST",
                data: new FormData(this),
                processData: false,
                contentType: false,
                cache: false,
                async: false,
                dataType: "JSON",
                success: function (result) 
                {
                    if (result.status == 'ok') 
                    {
                        reload_table(); 
                        $('.modal').modal('hide');
                        $('#id').val(''); 
                        $('#form').parsley().reset();
                        $('#form')[0].reset();
                        $('#submit').text('Save');
                        $('#submit').attr('disabled', false);
                        $(".alert-danger").hide();
                        $(".alert-success").show();
                        $(".alert-success-msg").html(result.message);                        
                        setTimeout(function () {
                            $(".alert-success").fadeOut(500);
                        }, 10000);
                    } 
                    else 
                    {
                        $('.modal').modal('hide');
                        $('#id').val(''); 
                        $('#form').parsley().reset();
                        $('#form')[0].reset();
                        $('#submit').text('Save');
                        $('#submit').attr('disabled', false);
                        $(".alert-success").hide();
                        $(".alert-danger").show();
                        $(".alert-danger-msg").html(result.message);
                        setTimeout(function () {
                            $(".alert-danger").fadeOut(500);
                        }, 10000);
                    }
                }
            });
         
    }
});
